Bullet Collision Detection & Physics Library: btGeneric6DofSpring2Constraint Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
btGeneric6DofSpring2Constraint Class Reference

`#include <btGeneric6DofSpring2Constraint.h>`

Inheritance diagram for btGeneric6DofSpring2Constraint:
[legend]
Collaboration diagram for btGeneric6DofSpring2Constraint:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btGeneric6DofSpring2Constraint (btRigidBody &rbA, btRigidBody &rbB, const btTransform &frameInA, const btTransform &frameInB, RotateOrder rotOrder=RO_XYZ)
| 2009 March: btGeneric6DofConstraint refactored by Roman Ponomarev Added support for generic constraint solver through getInfo1/getInfo2 methods
| btGeneric6DofSpring2Constraint (btRigidBody &rbB, const btTransform &frameInB, RotateOrder rotOrder=RO_XYZ)
virtual void | buildJacobian ()
| internal method used by the constraint solver, don't use them directly
virtual void | getInfo1 (btConstraintInfo1 *info)
| internal method used by the constraint solver, don't use them directly
virtual void | getInfo2 (btConstraintInfo2 *info)
| internal method used by the constraint solver, don't use them directly
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
btRotationalLimitMotor2 * | getRotationalLimitMotor (int index)
btTranslationalLimitMotor2 * | getTranslationalLimitMotor ()
void | calculateTransforms (const btTransform &transA, const btTransform &transB)
void | calculateTransforms ()
const btTransform & | getCalculatedTransformA () const
const btTransform & | getCalculatedTransformB () const
const btTransform & | getFrameOffsetA () const
const btTransform & | getFrameOffsetB () const
btTransform & | getFrameOffsetA ()
btTransform & | getFrameOffsetB ()
btVector3 | getAxis (int axis_index) const
btScalar | getAngle (int axis_index) const
btScalar | getRelativePivotPosition (int axis_index) const
void | setFrames (const btTransform &frameA, const btTransform &frameB)
void | setLinearLowerLimit (const btVector3 &linearLower)
void | getLinearLowerLimit (btVector3 &linearLower)
void | setLinearUpperLimit (const btVector3 &linearUpper)
void | getLinearUpperLimit (btVector3 &linearUpper)
void | setAngularLowerLimit (const btVector3 &angularLower)
void | setAngularLowerLimitReversed (const btVector3 &angularLower)
void | getAngularLowerLimit (btVector3 &angularLower)
void | getAngularLowerLimitReversed (btVector3 &angularLower)
void | setAngularUpperLimit (const btVector3 &angularUpper)
void | setAngularUpperLimitReversed (const btVector3 &angularUpper)
void | getAngularUpperLimit (btVector3 &angularUpper)
void | getAngularUpperLimitReversed (btVector3 &angularUpper)
void | setLimit (int axis, btScalar lo, btScalar hi)
void | setLimitReversed (int axis, btScalar lo, btScalar hi)
bool | isLimited (int limitIndex)
void | setRotationOrder (RotateOrder order)
RotateOrder | getRotationOrder ()
void | setAxis (const btVector3 &axis1, const btVector3 &axis2)
void | setBounce (int index, btScalar bounce)
void | enableMotor (int index, bool onOff)
void | setServo (int index, bool onOff)
void | setTargetVelocity (int index, btScalar velocity)
void | setServoTarget (int index, btScalar target)
void | setMaxMotorForce (int index, btScalar force)
void | enableSpring (int index, bool onOff)
void | setStiffness (int index, btScalar stiffness, bool limitIfNeeded=true)
void | setDamping (int index, btScalar damping, bool limitIfNeeded=true)
void | setEquilibriumPoint ()
void | setEquilibriumPoint (int index)
void | setEquilibriumPoint (int index, btScalar val)
virtual void | setParam (int num, btScalar value, int axis=-1)
| override the default global value of a parameter (such as ERP or CFM), optionally provide the axis (0..5).
virtual btScalar | getParam (int num, int axis=-1) const
| return the local value of parameter
Public Member Functions inherited from btTypedConstraint
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btTypedConstraint ()
| btTypedConstraint (btTypedConstraintType type, btRigidBody &rbA)
| btTypedConstraint (btTypedConstraintType type, btRigidBody &rbA, btRigidBody &rbB)
int | getOverrideNumSolverIterations () const
void | setOverrideNumSolverIterations (int overideNumIterations)
| override the number of constraint solver iterations used to solve this constraint -1 will use the default number of iterations, as specified in SolverInfo.m_numIterations
virtual void | buildJacobian ()
| internal method used by the constraint solver, don't use them directly
virtual void | setupSolverConstraint (btConstraintArray &ca, int solverBodyA, int solverBodyB, btScalar timeStep)
| internal method used by the constraint solver, don't use them directly
virtual void | getInfo1 (btConstraintInfo1 *info)=0
| internal method used by the constraint solver, don't use them directly
virtual void | getInfo2 (btConstraintInfo2 *info)=0
| internal method used by the constraint solver, don't use them directly
void | internalSetAppliedImpulse (btScalar appliedImpulse)
| internal method used by the constraint solver, don't use them directly
btScalar | internalGetAppliedImpulse ()
| internal method used by the constraint solver, don't use them directly
btScalar | getBreakingImpulseThreshold () const
void | setBreakingImpulseThreshold (btScalar threshold)
bool | isEnabled () const
void | setEnabled (bool enabled)
virtual void | solveConstraintObsolete (btSolverBody &, btSolverBody &, btScalar)
| internal method used by the constraint solver, don't use them directly
const btRigidBody & | getRigidBodyA () const
const btRigidBody & | getRigidBodyB () const
btRigidBody & | getRigidBodyA ()
btRigidBody & | getRigidBodyB ()
int | getUserConstraintType () const
void | setUserConstraintType (int userConstraintType)
void | setUserConstraintId (int uid)
int | getUserConstraintId () const
void | setUserConstraintPtr (void *ptr)
void * | getUserConstraintPtr ()
void | setJointFeedback (btJointFeedback *jointFeedback)
const btJointFeedback * | getJointFeedback () const
btJointFeedback * | getJointFeedback ()
int | getUid () const
bool | needsFeedback () const
void | enableFeedback (bool needsFeedback)
| enableFeedback will allow to read the applied linear and angular impulse use getAppliedImpulse, getAppliedLinearImpulse and getAppliedAngularImpulse to read feedback information
btScalar | getAppliedImpulse () const
| getAppliedImpulse is an estimated total applied impulse.
btTypedConstraintType | getConstraintType () const
void | setDbgDrawSize (btScalar dbgDrawSize)
btScalar | getDbgDrawSize ()
virtual void | setParam (int num, btScalar value, int axis=-1)=0
| override the default global value of a parameter (such as ERP or CFM), optionally provide the axis (0..5).
virtual btScalar | getParam (int num, int axis=-1) const =0
| return the local value of parameter
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
Public Member Functions inherited from btTypedObject
| btTypedObject (int objectType)
int | getObjectType () const

## Static Public Member Functions
static btScalar | btGetMatrixElem (const btMatrix3x3 &mat, int index)
static bool | matrixToEulerXYZ (const btMatrix3x3 &mat, btVector3 &xyz)
static bool | matrixToEulerXZY (const btMatrix3x3 &mat, btVector3 &xyz)
static bool | matrixToEulerYXZ (const btMatrix3x3 &mat, btVector3 &xyz)
static bool | matrixToEulerYZX (const btMatrix3x3 &mat, btVector3 &xyz)
static bool | matrixToEulerZXY (const btMatrix3x3 &mat, btVector3 &xyz)
static bool | matrixToEulerZYX (const btMatrix3x3 &mat, btVector3 &xyz)
Static Public Member Functions inherited from btTypedConstraint
static btRigidBody & | getFixedBody ()

## Protected Member Functions
btGeneric6DofSpring2Constraint & | operator= (const btGeneric6DofSpring2Constraint &)
int | setAngularLimits (btConstraintInfo2 *info, int row_offset, const btTransform &transA, const btTransform &transB, const btVector3 &linVelA, const btVector3 &linVelB, const btVector3 &angVelA, const btVector3 &angVelB)
int | setLinearLimits (btConstraintInfo2 *info, int row, const btTransform &transA, const btTransform &transB, const btVector3 &linVelA, const btVector3 &linVelB, const btVector3 &angVelA, const btVector3 &angVelB)
void | calculateLinearInfo ()
void | calculateAngleInfo ()
void | testAngularLimitMotor (int axis_index)
void | calculateJacobi (btRotationalLimitMotor2 *limot, const btTransform &transA, const btTransform &transB, btConstraintInfo2 *info, int srow, btVector3 &ax1, int rotational, int rotAllowed)
int | get_limit_motor_info2 (btRotationalLimitMotor2 *limot, const btTransform &transA, const btTransform &transB, const btVector3 &linVelA, const btVector3 &linVelB, const btVector3 &angVelA, const btVector3 &angVelB, btConstraintInfo2 *info, int row, btVector3 &ax1, int rotational, int rotAllowed=false)
Protected Member Functions inherited from btTypedConstraint
btScalar | getMotorFactor (btScalar pos, btScalar lowLim, btScalar uppLim, btScalar vel, btScalar timeFact)
| internal method used by the constraint solver, don't use them directly

## Protected Attributes
btTransform | m_frameInA
btTransform | m_frameInB
btJacobianEntry | m_jacLinear [3]
btJacobianEntry | m_jacAng [3]
btTranslationalLimitMotor2 | m_linearLimits
btRotationalLimitMotor2 | m_angularLimits [3]
RotateOrder | m_rotateOrder
btTransform | m_calculatedTransformA
btTransform | m_calculatedTransformB
btVector3 | m_calculatedAxisAngleDiff
btVector3 | m_calculatedAxis [3]
btVector3 | m_calculatedLinearDiff
btScalar | m_factA
btScalar | m_factB
bool | m_hasStaticBody
int | m_flags
Protected Attributes inherited from btTypedConstraint
btRigidBody & | m_rbA
btRigidBody & | m_rbB
btScalar | m_appliedImpulse
btScalar | m_dbgDrawSize
btJointFeedback * | m_jointFeedback

## Additional Inherited Members
Public Attributes inherited from btTypedObject
int | m_objectType

## Detailed Description

Definition at line 272 of file btGeneric6DofSpring2Constraint.h.

## Constructor & Destructor Documentation

## ◆ btGeneric6DofSpring2Constraint() [1/2]

btGeneric6DofSpring2Constraint::btGeneric6DofSpring2Constraint | ( | btRigidBody & | rbA,
|  | btRigidBody & | rbB,
|  | const btTransform & | frameInA,
|  | const btTransform & | frameInB,
|  | RotateOrder | rotOrder = `RO_XYZ`
| ) |  |

2009 March: btGeneric6DofConstraint refactored by Roman Ponomarev Added support for generic constraint solver through getInfo1/getInfo2 methods

Definition at line 46 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ btGeneric6DofSpring2Constraint() [2/2]

btGeneric6DofSpring2Constraint::btGeneric6DofSpring2Constraint | ( | btRigidBody & | rbB,
|  | const btTransform & | frameInB,
|  | RotateOrder | rotOrder = `RO_XYZ`
| ) |  |

not providing rigidbody A means implicitly using worldspace for body A

Definition at line 52 of file btGeneric6DofSpring2Constraint.cpp.

## Member Function Documentation

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btGeneric6DofSpring2Constraint::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ btGetMatrixElem()

btScalar btGeneric6DofSpring2Constraint::btGetMatrixElem | ( | const btMatrix3x3 & | mat,
|  | int | index
| ) |  |
| static

Definition at line 60 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ buildJacobian()

virtual void btGeneric6DofSpring2Constraint::buildJacobian | ( |  | ) |
| inlinevirtual

internal method used by the constraint solver, don't use them directly

Reimplemented from btTypedConstraint.

Definition at line 322 of file btGeneric6DofSpring2Constraint.h.

## ◆ calculateAngleInfo()

void btGeneric6DofSpring2Constraint::calculateAngleInfo | ( |  | ) |
| protected

Definition at line 269 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ calculateJacobi()

void btGeneric6DofSpring2Constraint::calculateJacobi | ( | btRotationalLimitMotor2 * | limot,
|  | const btTransform & | transA,
|  | const btTransform & | transB,
|  | btConstraintInfo2 * | info,
|  | int | srow,
|  | btVector3 & | ax1,
|  | int | rotational,
|  | int | rotAllowed
| ) |  |
| protected

Definition at line 637 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ calculateLinearInfo()

void btGeneric6DofSpring2Constraint::calculateLinearInfo | ( |  | ) |
| protected

Definition at line 626 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ calculateSerializeBufferSize()

int btGeneric6DofSpring2Constraint::calculateSerializeBufferSize | ( |  | ) | const
| inlinevirtual

Reimplemented from btTypedConstraint.

Definition at line 583 of file btGeneric6DofSpring2Constraint.h.

## ◆ calculateTransforms() [1/2]

void btGeneric6DofSpring2Constraint::calculateTransforms | ( |  | ) |

Definition at line 411 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ calculateTransforms() [2/2]

void btGeneric6DofSpring2Constraint::calculateTransforms | ( | const btTransform & | transA,
|  | const btTransform & | transB
| ) |  |

Definition at line 416 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ enableMotor()

void btGeneric6DofSpring2Constraint::enableMotor | ( | int | index,
|  | bool | onOff
| ) |  |

Definition at line 1050 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ enableSpring()

void btGeneric6DofSpring2Constraint::enableSpring | ( | int | index,
|  | bool | onOff
| ) |  |

Definition at line 1130 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ get_limit_motor_info2()

int btGeneric6DofSpring2Constraint::get_limit_motor_info2 | ( | btRotationalLimitMotor2 * | limot,
|  | const btTransform & | transA,
|  | const btTransform & | transB,
|  | const btVector3 & | linVelA,
|  | const btVector3 & | linVelB,
|  | const btVector3 & | angVelA,
|  | const btVector3 & | angVelB,
|  | btConstraintInfo2 * | info,
|  | int | row,
|  | btVector3 & | ax1,
|  | int | rotational,
|  | int | rotAllowed = `false`
| ) |  |
| protected

Definition at line 670 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ getAngle()

btScalar btGeneric6DofSpring2Constraint::getAngle | ( | int | axis_index | ) | const
| inline

Definition at line 350 of file btGeneric6DofSpring2Constraint.h.

## ◆ getAngularLowerLimit()

void btGeneric6DofSpring2Constraint::getAngularLowerLimit | ( | btVector3 & | angularLower | ) |
| inline

Definition at line 374 of file btGeneric6DofSpring2Constraint.h.

## ◆ getAngularLowerLimitReversed()

void btGeneric6DofSpring2Constraint::getAngularLowerLimitReversed | ( | btVector3 & | angularLower | ) |
| inline

Definition at line 380 of file btGeneric6DofSpring2Constraint.h.

## ◆ getAngularUpperLimit()

void btGeneric6DofSpring2Constraint::getAngularUpperLimit | ( | btVector3 & | angularUpper | ) |
| inline

Definition at line 398 of file btGeneric6DofSpring2Constraint.h.

## ◆ getAngularUpperLimitReversed()

void btGeneric6DofSpring2Constraint::getAngularUpperLimitReversed | ( | btVector3 & | angularUpper | ) |
| inline

Definition at line 404 of file btGeneric6DofSpring2Constraint.h.

## ◆ getAxis()

btVector3 btGeneric6DofSpring2Constraint::getAxis | ( | int | axis_index | ) | const
| inline

Definition at line 347 of file btGeneric6DofSpring2Constraint.h.

## ◆ getCalculatedTransformA()

const btTransform & btGeneric6DofSpring2Constraint::getCalculatedTransformA | ( |  | ) | const
| inline

Definition at line 336 of file btGeneric6DofSpring2Constraint.h.

## ◆ getCalculatedTransformB()

const btTransform & btGeneric6DofSpring2Constraint::getCalculatedTransformB | ( |  | ) | const
| inline

Definition at line 338 of file btGeneric6DofSpring2Constraint.h.

## ◆ getFrameOffsetA() [1/2]

btTransform & btGeneric6DofSpring2Constraint::getFrameOffsetA | ( |  | ) |
| inline

Definition at line 343 of file btGeneric6DofSpring2Constraint.h.

## ◆ getFrameOffsetA() [2/2]

const btTransform & btGeneric6DofSpring2Constraint::getFrameOffsetA | ( |  | ) | const
| inline

Definition at line 340 of file btGeneric6DofSpring2Constraint.h.

## ◆ getFrameOffsetB() [1/2]

btTransform & btGeneric6DofSpring2Constraint::getFrameOffsetB | ( |  | ) |
| inline

Definition at line 344 of file btGeneric6DofSpring2Constraint.h.

## ◆ getFrameOffsetB() [2/2]

const btTransform & btGeneric6DofSpring2Constraint::getFrameOffsetB | ( |  | ) | const
| inline

Definition at line 341 of file btGeneric6DofSpring2Constraint.h.

## ◆ getInfo1()

void btGeneric6DofSpring2Constraint::getInfo1 | ( | btConstraintInfo1 * | info | ) |
| virtual

internal method used by the constraint solver, don't use them directly

Implements btTypedConstraint.

Definition at line 446 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ getInfo2()

void btGeneric6DofSpring2Constraint::getInfo2 | ( | btConstraintInfo2 * | info | ) |
| virtual

internal method used by the constraint solver, don't use them directly

Implements btTypedConstraint.

Definition at line 476 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ getLinearLowerLimit()

void btGeneric6DofSpring2Constraint::getLinearLowerLimit | ( | btVector3 & | linearLower | ) |
| inline

Definition at line 358 of file btGeneric6DofSpring2Constraint.h.

## ◆ getLinearUpperLimit()

void btGeneric6DofSpring2Constraint::getLinearUpperLimit | ( | btVector3 & | linearUpper | ) |
| inline

Definition at line 360 of file btGeneric6DofSpring2Constraint.h.

## ◆ getParam()

btScalar btGeneric6DofSpring2Constraint::getParam | ( | int | num,
|  | int | axis = `-1`
| ) |  | const
| virtual

return the local value of parameter

Implements btTypedConstraint.

Definition at line 964 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ getRelativePivotPosition()

btScalar btGeneric6DofSpring2Constraint::getRelativePivotPosition | ( | int | axis_index | ) | const
| inline

Definition at line 353 of file btGeneric6DofSpring2Constraint.h.

## ◆ getRotationalLimitMotor()

btRotationalLimitMotor2 * btGeneric6DofSpring2Constraint::getRotationalLimitMotor | ( | int | index | ) |
| inline

Definition at line 328 of file btGeneric6DofSpring2Constraint.h.

## ◆ getRotationOrder()

RotateOrder btGeneric6DofSpring2Constraint::getRotationOrder | ( |  | ) |
| inline

Definition at line 454 of file btGeneric6DofSpring2Constraint.h.

## ◆ getTranslationalLimitMotor()

btTranslationalLimitMotor2 * btGeneric6DofSpring2Constraint::getTranslationalLimitMotor | ( |  | ) |
| inline

Definition at line 329 of file btGeneric6DofSpring2Constraint.h.

## ◆ isLimited()

bool btGeneric6DofSpring2Constraint::isLimited | ( | int | limitIndex | ) |
| inline

Definition at line 444 of file btGeneric6DofSpring2Constraint.h.

## ◆ matrixToEulerXYZ()

bool btGeneric6DofSpring2Constraint::matrixToEulerXYZ | ( | const btMatrix3x3 & | mat,
|  | btVector3 & | xyz
| ) |  |
| static

Definition at line 69 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ matrixToEulerXZY()

bool btGeneric6DofSpring2Constraint::matrixToEulerXZY | ( | const btMatrix3x3 & | mat,
|  | btVector3 & | xyz
| ) |  |
| static

Definition at line 104 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ matrixToEulerYXZ()

bool btGeneric6DofSpring2Constraint::matrixToEulerYXZ | ( | const btMatrix3x3 & | mat,
|  | btVector3 & | xyz
| ) |  |
| static

Definition at line 137 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ matrixToEulerYZX()

bool btGeneric6DofSpring2Constraint::matrixToEulerYZX | ( | const btMatrix3x3 & | mat,
|  | btVector3 & | xyz
| ) |  |
| static

Definition at line 170 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ matrixToEulerZXY()

bool btGeneric6DofSpring2Constraint::matrixToEulerZXY | ( | const btMatrix3x3 & | mat,
|  | btVector3 & | xyz
| ) |  |
| static

Definition at line 203 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ matrixToEulerZYX()

bool btGeneric6DofSpring2Constraint::matrixToEulerZYX | ( | const btMatrix3x3 & | mat,
|  | btVector3 & | xyz
| ) |  |
| static

Definition at line 236 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ operator=()

btGeneric6DofSpring2Constraint & btGeneric6DofSpring2Constraint::operator= | ( | const btGeneric6DofSpring2Constraint & |  | ) |
| inlineprotected

Definition at line 298 of file btGeneric6DofSpring2Constraint.h.

## ◆ serialize()

const char * btGeneric6DofSpring2Constraint::serialize | ( | void * | dataBuffer,
|  | btSerializer * | serializer
| ) |  | const
| inlinevirtual

fills the dataBuffer and returns the struct name (and 0 on failure)

Reimplemented from btTypedConstraint.

Definition at line 588 of file btGeneric6DofSpring2Constraint.h.

## ◆ setAngularLimits()

int btGeneric6DofSpring2Constraint::setAngularLimits | ( | btConstraintInfo2 * | info,
|  | int | row_offset,
|  | const btTransform & | transA,
|  | const btTransform & | transB,
|  | const btVector3 & | linVelA,
|  | const btVector3 & | linVelB,
|  | const btVector3 & | angVelA,
|  | const btVector3 & | angVelB
| ) |  |
| protected

Definition at line 546 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setAngularLowerLimit()

void btGeneric6DofSpring2Constraint::setAngularLowerLimit | ( | const btVector3 & | angularLower | ) |
| inline

Definition at line 362 of file btGeneric6DofSpring2Constraint.h.

## ◆ setAngularLowerLimitReversed()

void btGeneric6DofSpring2Constraint::setAngularLowerLimitReversed | ( | const btVector3 & | angularLower | ) |
| inline

Definition at line 368 of file btGeneric6DofSpring2Constraint.h.

## ◆ setAngularUpperLimit()

void btGeneric6DofSpring2Constraint::setAngularUpperLimit | ( | const btVector3 & | angularUpper | ) |
| inline

Definition at line 386 of file btGeneric6DofSpring2Constraint.h.

## ◆ setAngularUpperLimitReversed()

void btGeneric6DofSpring2Constraint::setAngularUpperLimitReversed | ( | const btVector3 & | angularUpper | ) |
| inline

Definition at line 392 of file btGeneric6DofSpring2Constraint.h.

## ◆ setAxis()

void btGeneric6DofSpring2Constraint::setAxis | ( | const btVector3 & | axis1,
|  | const btVector3 & | axis2
| ) |  |

Definition at line 1022 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setBounce()

void btGeneric6DofSpring2Constraint::setBounce | ( | int | index,
|  | btScalar | bounce
| ) |  |

Definition at line 1041 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setDamping()

void btGeneric6DofSpring2Constraint::setDamping | ( | int | index,
|  | btScalar | damping,
|  | bool | limitIfNeeded = `true`
| ) |  |

Definition at line 1154 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setEquilibriumPoint() [1/3]

void btGeneric6DofSpring2Constraint::setEquilibriumPoint | ( |  | ) |

Definition at line 1169 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setEquilibriumPoint() [2/3]

void btGeneric6DofSpring2Constraint::setEquilibriumPoint | ( | int | index | ) |

Definition at line 1179 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setEquilibriumPoint() [3/3]

void btGeneric6DofSpring2Constraint::setEquilibriumPoint | ( | int | index,
|  | btScalar | val
| ) |  |

Definition at line 1189 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setFrames()

void btGeneric6DofSpring2Constraint::setFrames | ( | const btTransform & | frameA,
|  | const btTransform & | frameB
| ) |  |

Definition at line 618 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setLimit()

void btGeneric6DofSpring2Constraint::setLimit | ( | int | axis,
|  | btScalar | lo,
|  | btScalar | hi
| ) |  |
| inline

Definition at line 412 of file btGeneric6DofSpring2Constraint.h.

## ◆ setLimitReversed()

void btGeneric6DofSpring2Constraint::setLimitReversed | ( | int | axis,
|  | btScalar | lo,
|  | btScalar | hi
| ) |  |
| inline

Definition at line 428 of file btGeneric6DofSpring2Constraint.h.

## ◆ setLinearLimits()

int btGeneric6DofSpring2Constraint::setLinearLimits | ( | btConstraintInfo2 * | info,
|  | int | row,
|  | const btTransform & | transA,
|  | const btTransform & | transB,
|  | const btVector3 & | linVelA,
|  | const btVector3 & | linVelB,
|  | const btVector3 & | angVelA,
|  | const btVector3 & | angVelB
| ) |  |
| protected

Definition at line 490 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setLinearLowerLimit()

void btGeneric6DofSpring2Constraint::setLinearLowerLimit | ( | const btVector3 & | linearLower | ) |
| inline

Definition at line 357 of file btGeneric6DofSpring2Constraint.h.

## ◆ setLinearUpperLimit()

void btGeneric6DofSpring2Constraint::setLinearUpperLimit | ( | const btVector3 & | linearUpper | ) |
| inline

Definition at line 359 of file btGeneric6DofSpring2Constraint.h.

## ◆ setMaxMotorForce()

void btGeneric6DofSpring2Constraint::setMaxMotorForce | ( | int | index,
|  | btScalar | force
| ) |  |

Definition at line 1121 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setParam()

void btGeneric6DofSpring2Constraint::setParam | ( | int | num,
|  | btScalar | value,
|  | int | axis = `-1`
| ) |  |
| virtual

override the default global value of a parameter (such as ERP or CFM), optionally provide the axis (0..5).

If no axis is provided, it uses the default axis for this constraint.

Implements btTypedConstraint.

Definition at line 907 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setRotationOrder()

void btGeneric6DofSpring2Constraint::setRotationOrder | ( | RotateOrder | order | ) |
| inline

Definition at line 453 of file btGeneric6DofSpring2Constraint.h.

## ◆ setServo()

void btGeneric6DofSpring2Constraint::setServo | ( | int | index,
|  | bool | onOff
| ) |  |

Definition at line 1059 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setServoTarget()

void btGeneric6DofSpring2Constraint::setServoTarget | ( | int | index,
|  | btScalar | target
| ) |  |

Definition at line 1077 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setStiffness()

void btGeneric6DofSpring2Constraint::setStiffness | ( | int | index,
|  | btScalar | stiffness,
|  | bool | limitIfNeeded = `true`
| ) |  |

Definition at line 1139 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ setTargetVelocity()

void btGeneric6DofSpring2Constraint::setTargetVelocity | ( | int | index,
|  | btScalar | velocity
| ) |  |

Definition at line 1068 of file btGeneric6DofSpring2Constraint.cpp.

## ◆ testAngularLimitMotor()

void btGeneric6DofSpring2Constraint::testAngularLimitMotor | ( | int | axis_index | ) |
| protected

Definition at line 438 of file btGeneric6DofSpring2Constraint.cpp.

## Member Data Documentation

## ◆ m_angularLimits

btRotationalLimitMotor2 btGeneric6DofSpring2Constraint::m_angularLimits[3]
| protected

Definition at line 283 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_calculatedAxis

btVector3 btGeneric6DofSpring2Constraint::m_calculatedAxis[3]
| protected

Definition at line 291 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_calculatedAxisAngleDiff

btVector3 btGeneric6DofSpring2Constraint::m_calculatedAxisAngleDiff
| protected

Definition at line 290 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_calculatedLinearDiff

btVector3 btGeneric6DofSpring2Constraint::m_calculatedLinearDiff
| protected

Definition at line 292 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_calculatedTransformA

btTransform btGeneric6DofSpring2Constraint::m_calculatedTransformA
| protected

Definition at line 288 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_calculatedTransformB

btTransform btGeneric6DofSpring2Constraint::m_calculatedTransformB
| protected

Definition at line 289 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_factA

btScalar btGeneric6DofSpring2Constraint::m_factA
| protected

Definition at line 293 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_factB

btScalar btGeneric6DofSpring2Constraint::m_factB
| protected

Definition at line 294 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_flags

int btGeneric6DofSpring2Constraint::m_flags
| protected

Definition at line 296 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_frameInA

btTransform btGeneric6DofSpring2Constraint::m_frameInA
| protected

Definition at line 276 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_frameInB

btTransform btGeneric6DofSpring2Constraint::m_frameInB
| protected

Definition at line 277 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_hasStaticBody

bool btGeneric6DofSpring2Constraint::m_hasStaticBody
| protected

Definition at line 295 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_jacAng

btJacobianEntry btGeneric6DofSpring2Constraint::m_jacAng[3]
| protected

Definition at line 280 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_jacLinear

btJacobianEntry btGeneric6DofSpring2Constraint::m_jacLinear[3]
| protected

Definition at line 279 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_linearLimits

btTranslationalLimitMotor2 btGeneric6DofSpring2Constraint::m_linearLimits
| protected

Definition at line 282 of file btGeneric6DofSpring2Constraint.h.

## ◆ m_rotateOrder

RotateOrder btGeneric6DofSpring2Constraint::m_rotateOrder
| protected

Definition at line 285 of file btGeneric6DofSpring2Constraint.h.

The documentation for this class was generated from the following files:

- btGeneric6DofSpring2Constraint.h
- btGeneric6DofSpring2Constraint.cpp